<?php
namespace Claromentis\Console\Util;

$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] = (@$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"] ?: array()) + array("_3e09962b663b985bf8c2" . "60ac2e95edc0" => base64_decode("Y29y" . "ZQ=="), "_9810a28102741" . "28200cb24f1590" . "9a3f2" => base64_decode("Q2hlY2tpbmcgZGF" . "0YWJhc2UgcGVybW" . "lzc2lvbnMuLi4="), "_1094b9765" . "16d8df5406" . "7d448e66e0" . "297" => base64_decode("RGF0YWJhc2UgaX" . "MgYXZhaWxhYmxl"), "_7b2ca9a1" . "05acfcc08" . "8d2c15bfe" . "6458b6" => base64_decode("Q29yZSBpcyBub3QgaW5z" . "dGFsbGVk"), "_9636e445fbeaa4b" . "bfe5694ed532de0b" . "1" => base64_decode("RGF0YWJhc2UgcGVybWlzc2lvbn" . "MgaW5zdWZmaWNpZW50"), "_5bcefc1eff68a2aa6ab8f35699" . "a56d08" => base64_decode("RGF0YWJhc" . "2UgaXMgbm" . "90IGF2YWl" . "sYWJsZTog"), "_77713ce23683636d0573408c9a" . "0d0ddb" => base64_decode("RGF0YWJhc2UgcGVybWlzc2lvbnMgYXJlIGFk" . "ZXF1YXRl"), "_a70083b91f8d3b0237061e06826" . "958e8" => base64_decode("Q2hlY2tpbmcgZGF0YWJhc2" . "UgYXZhaWxhYmlsaXR5Li4u"), "_4c93d4c40f7ab1a488" . "c387f7f91a6496" => base64_decode("Q2hlY2tpbmcgaW5zdGFsbGF0aW9" . "uLi4u"));
use Claromentis\Core\Config\Config;
use Claromentis\Core\DAL\DbFactory;
use Claromentis\Core\Module;
use Claromentis\Setup\Exception\NotInstalledException;
use Claromentis\Setup\Task\DatabaseCheck;
use Psr\Log\LoggerAwareInterface;
use Psr\Log\LoggerAwareTrait;
use Psr\Log\NullLogger;
use RuntimeException;




class InstallationChecker implements LoggerAwareInterface
{
    use LoggerAwareTrait;
    protected Config $config;
    protected DbFactory $factory;
    protected Locator $locator;
    protected Module\Api $modules;
    
    
    
    
    
    
    
    
    
    public function __construct(Config $_fd33b1a14db9a1eccfaaa3cb67b5336e, DbFactory $_c8ef295ed962a46e6246480731bf7b99, Locator $_958a49c0e9814c5c29eb8698e3fb6de2, Module\Api $_59eea0afb98cc6c83c49d730362a45fd)
    {
        $this->config = $_fd33b1a14db9a1eccfaaa3cb67b5336e;
        $this->factory = $_c8ef295ed962a46e6246480731bf7b99;
        $this->locator = $_958a49c0e9814c5c29eb8698e3fb6de2;
        $this->modules = $_59eea0afb98cc6c83c49d730362a45fd;
        $this->setLogger(new NullLogger());
    }
    
    
    
    
    
    
    public function isInstalled()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_4c93d4c40f7ab1a488c387f7f91a" . "6496"]);
            $this->verifyInstalled();
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    public function checkDatabaseConnection()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_a70083b91f8" . "d3b0237061e0" . "6826958e8"]);
            $this->verifyDatabaseConnection();
            $this->logger->debug($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_1094b97" . "6516d8df" . "54067d44" . "8e66e029" . "7"]);
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            
            
            
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_5bcefc1eff68a2aa6ab8f35699a56d" . "08"] . $_c35473364fa7a050299058f332ec29c1->getMessage());
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    public function checkDatabasePermissions()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_9810a2810274128200c" . "b24f15909a3f2"]);
            $this->verifyDatabasePermissions();
            $this->logger->debug($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_77713ce23683636d0573408c9" . "a0d0ddb"]);
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            
            
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    
    public function verifyInstalled()
    {
        $this->verifyDatabaseConnection();
        $this->verifyDatabasePermissions();
        if (!$this->modules->isInstalled($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_3e09962b663b985bf8c2" . "60ac2e95edc0"])) {
            throw new NotInstalledException($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_7b2ca9a105acfcc088d2c1" . "5bfe6458b6"]);
        }
    }
    
    
    
    
    
    
    
    public function verifyDatabaseConnection()
    {
        
        
        $_4504853ce5094b088c8bdc3d570a0a5d = $this->getDatabase();
        
        
        $this->modules->setDatabase($_4504853ce5094b088c8bdc3d570a0a5d);
    }
    
    
    
    
    
    
    
    public function verifyDatabasePermissions()
    {
        $_4504853ce5094b088c8bdc3d570a0a5d = $this->getDatabase();
        $_58bc0ced402c33be307fe4d3d5433ed1 = new DatabaseCheck($this->config, $_4504853ce5094b088c8bdc3d570a0a5d);
        $_58bc0ced402c33be307fe4d3d5433ed1->setLogger($this->logger);
        if (!$_58bc0ced402c33be307fe4d3d5433ed1->Check()) {
            foreach ($_58bc0ced402c33be307fe4d3d5433ed1->GetErrors() as $_ba3845cb79c005cf3269af8c83ddbe5e) {
                $this->logger->error($_ba3845cb79c005cf3269af8c83ddbe5e);
            }
            throw new RuntimeException($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_9636e445fbeaa4bbfe5694ed532de0b" . "1"]);
        }
    }
    
    
    
    
    
    
    
    protected function getDatabase()
    {
        return $this->factory->GetInstanceFromConfig($this->config);
    }
}